#coding=utf-8
import os
import codecs
import cchardet 
import chardet 
from optparse import OptionParser
from multiprocessing import Pool

#reload(sys)
#sys.setdefaultencoding("utf-8")

def utf8_converter(file_path):
    '''
    Convert any type of file to UTF-8

    Parameters
    ----------
    file_path : string, file path.
    '''

    # Fix file path
    file_path = os.path.realpath(os.path.expanduser(file_path))

    if not os.path.isfile(file_path):
        print '[WARN] filepath is not a file: ' + file_path

    # Read from file
    file_open = open(file_path)
    raw = file_open.read()
    file_open.close()

    file_encoding_chardet = str(chardet.detect(raw)['encoding'])
    file_encoding_cchardet = str(cchardet.detect(raw)['encoding'])
    #'will print: [INFO]  chardet code is : ISO-8859-2
    print "[INFO] %s code is : %s"%(" chardet",file_encoding_chardet)

    #will print [INFO] cchardet code is : WINDOWS-1252
    print "[INFO] %s code is : %s"%("cchardet",file_encoding_cchardet)


    # Decode then Encode to UTF-8
    raw_decode_by_chardet_then_encode_utf8=raw.decode(file_encoding_chardet,'ignore').encode('utf8')
    raw_decode_by_cchardet_then_encode_utf8=raw.decode(file_encoding_cchardet,'ignore').encode('utf8')
    raw_decode_by_GB2312_encode_utf8=raw.decode('GB2312','ignore').encode('utf8')
    

    # Write to file
    file_open_chardet = open(file_path+".chardet.cs", 'w')
    file_open_chardet.write(raw_decode_by_chardet_then_encode_utf8)
    file_open_chardet.close()

    file_open_cchardet = open(file_path+".cchardet.cs", 'w')
    file_open_cchardet.write(raw_decode_by_cchardet_then_encode_utf8)
    file_open_cchardet.close()

    file_open = open(file_path+".GB2312.cs", 'w')
    file_open.write(raw_decode_by_GB2312_encode_utf8)
    file_open.close()

    return 0



if __name__ == "__main__":
    file_path='testfile.cs'
    utf8_converter(file_path)
        
